From 4c2473b73d66b2835899ad8046fba6aac129f374 Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Sun, 1 Mar 2020 19:35:07 +0530
Subject: [PATCH 1/2] LCD 3.5 LK Changes

Change-Id: Ie9228442d4445be621b724aa1ba0e8c5257e2a5e
---
 dev/gcdb/display/include/panel_ili9488c_720p_cmd.h | 257 +++++++++++++++++++++
 target/msm8909/oem_panel.c                         |  31 ++-
 2 files changed, 285 insertions(+), 3 deletions(-)
 create mode 100644 dev/gcdb/display/include/panel_ili9488c_720p_cmd.h

diff --git a/dev/gcdb/display/include/panel_ili9488c_720p_cmd.h b/dev/gcdb/display/include/panel_ili9488c_720p_cmd.h
new file mode 100644
index 0000000..a2152a7
--- /dev/null
+++ b/dev/gcdb/display/include/panel_ili9488c_720p_cmd.h
@@ -0,0 +1,257 @@
+/* Copyright (c) 2013, The Linux Foundation. All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *  * Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *  * Neither the name of The Linux Foundation nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
+ * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
+ * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/*---------------------------------------------------------------------------
+ * This file is autogenerated file using gcdb parser. Please do not edit it.
+ * Update input XML file to add a new entry or update variable in this file
+ * VERSION = "1.0"
+ *---------------------------------------------------------------------------*/
+
+#ifndef _PANEL_ILI9488C_720P_CMD_H_
+#define _PANEL_ILI9488C_720P_CMD_H_
+/*---------------------------------------------------------------------------*/
+/* HEADER files                                                              */
+/*---------------------------------------------------------------------------*/
+#include "panel.h"
+
+/*---------------------------------------------------------------------------*/
+/* Panel configuration                                                       */
+/*---------------------------------------------------------------------------*/
+static struct panel_config ili9488c_720p_cmd_panel_data = {
+	"qcom,mdss_dsi_ili9488c_720p_cmd", "dsi:0:", "qcom,mdss-dsi-panel",
+	10, 1, "DISPLAY_1", 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
+/*---------------------------------------------------------------------------*/
+/* Panel resolution                                                          */
+/*---------------------------------------------------------------------------*/
+static struct panel_resolution ili9488c_720p_cmd_panel_res = {
+	320, 480, 5, 20, 2, 0, 2, 6, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
+/*---------------------------------------------------------------------------*/
+/* Panel color information                                                   */
+/*---------------------------------------------------------------------------*/
+static struct color_info ili9488c_720p_cmd_color = {
+	24, 0, 0xff, 0, 0, 0
+};
+
+/*---------------------------------------------------------------------------*/
+/* Panel on/off command information                                          */
+/*---------------------------------------------------------------------------*/
+static char ili9488c_720p_cmd_on_cmd0[] = {
+	0x03, 0x00, 0x39, 0xC0,
+	0xC0, 0x17, 0x17, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd1[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0xC1, 0x44, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd2[] = {
+	0x04, 0x00, 0x39, 0xC0,
+	0xC5, 0x00, 0x35, 0x80,
+};
+
+static char ili9488c_720p_cmd_on_cmd3[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0x36, 0x08, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd4[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0x3A, 0x77, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd5[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0xB1, 0xA0, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd6[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0xB4, 0x02, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd7[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0xE9, 0x00, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd8[] = {
+	0x05, 0x00, 0x39, 0xC0,
+	0xF7, 0xA9, 0x51, 0x2C,
+	0x82, 0xFF, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd9[] = {
+	0x10, 0x00, 0x39, 0xC0,
+	0xE0, 0x01, 0x13, 0x1E,
+	0x00, 0x0D, 0x03, 0x3D,
+	0x55, 0x4F, 0x06, 0x10,
+	0x0B, 0x2C, 0x32, 0x0F,
+};
+
+static char ili9488c_720p_cmd_on_cmd10[] = {
+	0x10, 0x00, 0x39, 0xC0,
+	0xE1, 0x08, 0x10, 0x15,
+	0x03, 0x0E, 0x03, 0x32,
+	0x34, 0x44, 0x07, 0x10,
+	0x0E, 0x23, 0x2E, 0x0F,
+};
+
+static char ili9488c_720p_cmd_on_cmd11[] = {
+	0x04, 0x00, 0x39, 0xC0,
+	0xB6, 0x00, 0x22, 0x3B,
+};
+
+static char ili9488c_720p_cmd_on_cmd12[] = {
+	0x05, 0x00, 0x39, 0xC0,
+	0x2A, 0x00, 0x00, 0x01,
+	0x3F, 0xFF, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd13[] = {
+	0x05, 0x00, 0x39, 0xC0,
+	0x2B, 0x00, 0x00, 0x01,
+	0xDF, 0xFF, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd14[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0x21, 0x00, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd15[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0x11, 0x00, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd16[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0x29, 0x00, 0xFF, 0xFF,
+};
+
+static char ili9488c_720p_cmd_on_cmd17[] = {
+	0x02, 0x00, 0x39, 0xC0,
+	0x2C, 0x00, 0xFF, 0xFF,
+};
+
+static struct mipi_dsi_cmd ili9488c_720p_cmd_on_command[] = {
+	{0x8, ili9488c_720p_cmd_on_cmd0, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd1, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd2, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd3, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd4, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd5, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd6, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd7, 0x00},
+	{0xc, ili9488c_720p_cmd_on_cmd8, 0x00},
+	{0x14, ili9488c_720p_cmd_on_cmd9, 0x00},
+	{0x14, ili9488c_720p_cmd_on_cmd10, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd11, 0x00},
+	{0xc, ili9488c_720p_cmd_on_cmd12, 0x00},
+	{0xc, ili9488c_720p_cmd_on_cmd13, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd14, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd15, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd16, 0x00},
+	{0x8, ili9488c_720p_cmd_on_cmd17, 0x00}
+};
+
+#define ILI9488C_720P_CMD_ON_COMMAND 18
+
+
+static char ili9488c_720p_cmdoff_cmd0[] = {
+	0x28, 0x00, 0x05, 0x80
+};
+
+static char ili9488c_720p_cmdoff_cmd1[] = {
+	0x10, 0x00, 0x05, 0x80
+};
+
+static struct mipi_dsi_cmd ili9488c_720p_cmd_off_command[] = {
+	{0x4, ili9488c_720p_cmdoff_cmd0, 0x32},
+	{0x4, ili9488c_720p_cmdoff_cmd1, 0x78}
+};
+
+#define ILI9488C_720P_CMD_OFF_COMMAND 2
+
+
+static struct command_state ili9488c_720p_cmd_state = {
+	0, 1
+};
+
+/*---------------------------------------------------------------------------*/
+/* Command mode panel information                                            */
+/*---------------------------------------------------------------------------*/
+static struct commandpanel_info ili9488c_720p_cmd_command_panel = {
+	1, 1, 1, 0, 0, 0x2c, 0, 0, 0, 1, 0, 0
+};
+
+/*---------------------------------------------------------------------------*/
+/* Video mode panel information                                              */
+/*---------------------------------------------------------------------------*/
+static struct videopanel_info ili9488c_720p_cmd_video_panel = {
+	1, 0, 0, 0, 1, 1, 2, 0, 0x9
+};
+
+/*---------------------------------------------------------------------------*/
+/* Lane configuration                                                        */
+/*---------------------------------------------------------------------------*/
+static struct lane_configuration ili9488c_720p_cmd_lane_config = {
+	1, 0, 1, 0, 0, 0
+};
+
+/*---------------------------------------------------------------------------*/
+/* Panel timing                                                              */
+/*---------------------------------------------------------------------------*/
+static const uint32_t ili9488c_720p_cmd_timings[] = {
+	0x37, 0x0a, 0x04, 0x00, 0x22, 0x26, 0x08, 0x0e, 0x05, 0x03, 0x04, 0x00
+};
+
+static struct panel_timing ili9488c_720p_cmd_timing_info = {
+	0, 4, 0x05, 0x15
+};
+
+/*---------------------------------------------------------------------------*/
+/* Panel reset sequence                                                      */
+/*---------------------------------------------------------------------------*/
+static struct panel_reset_sequence ili9488c_720p_cmd_reset_seq = {
+	{1, 0, 1, }, {20, 2, 20, }, 2
+};
+
+/*---------------------------------------------------------------------------*/
+/* Backlight setting                                                         */
+/*---------------------------------------------------------------------------*/
+static struct backlight ili9488c_720p_cmd_backlight = {
+	1, 1, 4095, 100, 1, "PMIC_8941"
+};
+
+#endif /*_PANEL_ILI9488C_720P_CMD_H_*/
diff --git a/target/msm8909/oem_panel.c b/target/msm8909/oem_panel.c
index 949ed0f..fc54da2 100644
--- a/target/msm8909/oem_panel.c
+++ b/target/msm8909/oem_panel.c
@@ -50,7 +50,7 @@
 #include "include/panel_auo_cx_qvga_cmd.h"
 #include "include/panel_hx8394f_720p_video.h"
 #include "include/panel_ili9881c_720p_video.h"
-
+#include "include/panel_ili9488c_720p_cmd.h"
 #define DISPLAY_MAX_PANEL_DETECTION 2
 #define ILI9806E_FWVGA_VIDEO_PANEL_POST_INIT_DELAY 68
 
@@ -88,6 +88,7 @@ enum {
 	AUO_CX_QVGA_CMD_PANEL,
 	HX8394F_720P_VIDEO_PANEL,
 	ILI9881C_720P_VIDEO_PANEL,
+        ILI9448C_720P_CMD_PANEL,
 	UNKNOWN_PANEL
 };
 
@@ -109,6 +110,7 @@ static struct panel_list supp_panels[] = {
 	{"auo_cx_qvga_cmd", AUO_CX_QVGA_CMD_PANEL},
 	{"hx8394f_720p_video", HX8394F_720P_VIDEO_PANEL},
 	{"ili9881c_720p_video", ILI9881C_720P_VIDEO_PANEL},
+        {"ili9448c_720p_cmd", ILI9448C_720P_CMD_PANEL},
 };
 
 static uint32_t panel_id;
@@ -146,6 +148,28 @@ static int init_panel_data(struct panel_struct *panelstruct,
 	int pan_type = PANEL_TYPE_DSI;
 
 	switch (panel_id) {
+        case ILI9448C_720P_CMD_PANEL:
+                panelstruct->paneldata    = &ili9488c_720p_cmd_panel_data;
+                panelstruct->panelres     = &ili9488c_720p_cmd_panel_res;
+                panelstruct->color                = &ili9488c_720p_cmd_color;
+                panelstruct->videopanel   = &ili9488c_720p_cmd_video_panel;
+                panelstruct->commandpanel = &ili9488c_720p_cmd_command_panel;
+                panelstruct->state                = &ili9488c_720p_cmd_state;
+                panelstruct->laneconfig   = &ili9488c_720p_cmd_lane_config;
+                panelstruct->paneltiminginfo
+                                        = &ili9488c_720p_cmd_timing_info;
+                panelstruct->panelresetseq
+                                         = &ili9488c_720p_cmd_reset_seq;
+                panelstruct->backlightinfo = &ili9488c_720p_cmd_backlight;
+                pinfo->mipi.panel_cmds
+                                        = ili9488c_720p_cmd_on_command;
+                pinfo->mipi.num_of_panel_cmds
+                                       = ILI9488C_720P_CMD_ON_COMMAND;
+                memcpy(phy_db->timing,
+                             ili9488c_720p_cmd_timings, TIMING_SIZE);
+
+        break;
+
 	case HX8394D_480P_VIDEO_PANEL:
 		panelstruct->paneldata	  = &hx8394d_480p_video_panel_data;
 		panelstruct->panelres	  = &hx8394d_480p_video_panel_res;
@@ -480,7 +504,7 @@ int oem_panel_select(const char *panel_name, struct panel_struct *panelstruct,
 
 				break;
 			default:
-				if(auto_pan_loop == 0)
+			/*	if(auto_pan_loop == 0)
 				{
 					panel_id = ILI9881C_720P_VIDEO_PANEL;
 					auto_pan_loop++;
@@ -491,7 +515,8 @@ int oem_panel_select(const char *panel_name, struct panel_struct *panelstruct,
 					panel_id = HX8394F_720P_VIDEO_PANEL;
 					auto_pan_loop++;
 					break;
-				}
+				}*/
+                                panel_id = ILI9448C_720P_CMD_PANEL;
 		}
 		break;
 	case HW_PLATFORM_QRD:
-- 
2.7.4

